---
title: XRInputSource.gripSpace
slug: Web/API/XRInputSource/gripSpace
tags:
  - API
  - AR
  - Augmented Reality
  - Experimental
  - Property
  - Reference
  - VR
  - Virtual Reality
  - WebXR
  - WebXR Device API
  - XRInputSession
  - gripSpace
---
<div>{{securecontext_header}}{{APIRef("WebXR")}}</div>

<p class="summary"><span class="seoSummary">The read-only {{domxref("XRInputSource")}} property <code><strong>gripSpace</strong></code> returns an {{domxref("XRSpace")}} whose native origin tracks the pose used to render virtual objects so they appear to be held in (or part of) the user's hand.</span> For example, if a user were holding a virtual straight rod, the native origin of this <code>XRSpace</code> would be located at the approximate center of mass of the user's fist.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <var>xrSpace</var> = <em>xrInputSource</em>.gripSpace;</pre>

<h3 id="Value">Value</h3>

<p>An {{domxref("XRSpace")}} object representing the position and orientation of the input device in virtual space, suitable for rendering an image of the device into the scene. <code>gripSpace</code> is <code>null</code> if the input source is inherently untrackable. For example, only inputs whose {{domxref("XRInputSource.targetRayMode", "targetRayMode")}} is <code>tracked-pointer</code> provide a <code>gripSpace</code>.</p>

<p>Imagine that the controller is shaped like a straight rod, held in the user's fist. The native origin of the grip space is located at the centroid—the center of mass—of the user's fist, tracking the position of the user's hand.</p>

<div style="width: 42em;">
<div style="width: 20em; float: left;">
<figure style="background: #eee; padding: 0.5em; border: 1px solid #aaa; border-radius: 1em; max-width: 504px; padding: 1em; margin: 1em auto;">
<figcaption><strong>The coordinate system for the left hand's grip space.</strong></figcaption>

<div style="background-color: #FFF;"><img alt="A diagram showing how the grip space indicates the local coordinate system for the player's hand relative to the world." src="https://mdn.mozillademos.org/files/17260/GripSpace-LeftHand-Light.svg" style="width: 100%;"></div>
</figure>
</div>

<div style="width: 20em; float: right;">
<figure style="background: #eee; padding: 0.5em; border: 1px solid #aaa; border-radius: 1em; max-width: 504px; padding: 1em; margin: 1em auto;">
<figcaption><strong>The coordinate system for the right hand's grip space.</strong></figcaption>

<div style="background-color: #FFF;"><img alt="A diagram showing how the grip space indicates the local coordinate system for the player's hand relative to the world." src="https://mdn.mozillademos.org/files/17261/GripSpace-RightHand-Light.svg" style="width: 100%;"></div>
</figure>
</div>
</div>

<p class="cleared">As shown in the diagram above, the coordinate system is oriented as follows:</p>

<ul>
 <li>The x-axis is perpendicular to the palm of the user's hand, with the direction extending outward from the back of the hand being +X if the controller is in the user's right hand or -X if the controller is in the left hand.</li>
 <li>The z-axis along the length of the rod, parallel to the user's palm and along the length of their grip. -Z is in the direction of the user's thumb, and +Z is in the opposite direction.</li>
 <li>The y-axis is implied by the relationship between the other two axes; as is always the case, it's the cross product of the other two axes (lying 90° away from both the X and Z axes).</li>
</ul>

<h2 id="Examples">Examples</h2>

<p>In tis example, taken from the frame rendering callback, the <code>gripSpace</code> is used to render a mesh that represents the position and orieintation of the controller in the virtual environment.</p>

<pre class="brush: js notranslate">for (let source in xrSession.inputSources) {
  if (source.gripSpace) {
    let gripPose = frame.getPose(source.gripSpace, xrRefSpace);

    if (gripPose) {
      myDrawMeshUsingTransform(controllerMesh, gripPose.transform.matrix);
    }
  }
}
</pre>

<p>For each input source which has a value for <code>gripSpace</code>, this loop obtains the {{domxref("XRPose")}} representing the position and orientation that are described by <code>gripSpace</code>. If a valid pose is returned, a method <code>myDrawMeshUsingTransform()</code> is called to  draw the controller's mesh transformed using the grip pose's transform matrix.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebXR','#dom-xrinputsource-gripspace','XRInputSource.gripSpace')}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRInputSource.gripSpace")}}</p>
